import static java.awt.Color.WHITE;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.HashMap;

import javax.imageio.ImageIO;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

public class BuyCart extends HttpServlet {
  private static final int width=200, height=200;
  @Override
  protected void doGet(HttpServletRequest req, HttpServletResponse res) 
  throws ServletException, IOException {
    String account;
    
    HttpSession session = req.getSession(false);
    if(session==null || (account=(String)session.getAttribute("account"))==null) {
      res.sendRedirect(res.encodeRedirectURL("jsp/LoginFailed.jsp"));
    } else {  
      ArrayList<String> cart = (ArrayList<String>)session.getAttribute("cart");
      HashMap<String, Integer> colors = (HashMap<String, Integer>)session.getAttribute("colors");
      
      ArrayList<Color> cs = new ArrayList<Color>();
      for(String tmp : cart) {
        cs.add(new Color(colors.get(tmp)));
      }
      BufferedImage img = new BufferedImage(width, height, BufferedImage.TYPE_INT_ARGB);
      paint(img.createGraphics(), cs, account);
      
      res.setContentType("image/png");
      OutputStream out = res.getOutputStream();
      ImageIO.write(img, "png", out);
      out.close();     
    }
  }
  
  
  private void paint(Graphics2D g, ArrayList<Color> cs, String account) {
    g.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
    g.setBackground(WHITE);
    g.clearRect(0, 0, width, height);
    g.setColor(new Color(0x130c0e));
    g.fillOval(0, 0, 200, 200);
    int i;
    for (i=cs.size(); i>0; i--) {
      g.setColor(cs.get(i-1));
      g.fillOval(100-10*i, 100-10*i, 20*i, 20*i);
    }
    g.setColor(new Color(0xed1941));
    g.drawString(String.format("designed by %s", account), 5, height-10);
  }
}
